// Forlix SoScore
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs


public Event_PlayerTeam(Handle:event,
                        const String:name[],
                        bool:dontBroadcast)
{
  new client = GetClientOfUserId(GetEventInt(event, "userid"));

  new oldteam = GetEventInt(event, "oldteam");
  new newteam = GetEventInt(event, "team");

  if(oldteam > 1
  && newteam == 1)
  // change from CT or TERRORIST to SPECTATOR
  // if this happens within 2 seconds after suicide, CS:S gives player +1 frag...
    SetFrags(client, p_score[client], true);

  return;
}


public Event_PlayerSpawn(Handle:event,
                         const String:name[],
                         bool:dontBroadcast)
{
  new client = GetClientOfUserId(GetEventInt(event, "userid"));

  if(!GetClientTeam(client))
  // not an actual spawn (just "entered the game")
    return;

  AbortRespawnBlocktimer(client);

  p_spawned_in_round[client] = true;
  p_died_from_goal[client] = false;

  p_teamchooselock[client] = 0;

  if(player_godmode_health)
  // this shouldnt be done for the losing team while they are dying
  // but we have TeamDeathFailSafe so it doesnt matter
  {
    SetEntProp(client, Prop_Data, "m_takedamage", 0, 1);
    SetEntProp(client, Prop_Data, "m_iHealth", player_godmode_health, 1);
  }

  if(!p_spawned[client])
  // players first spawn since connect
  {
    p_spawned[client] = true;

    if(announcement_type == 1)
      PrintAnnouncementMsg(client);
  }

  return;
}


public Event_RoundStart(Handle:event,
                        const String:name[],
                        bool:dontBroadcast)
{
  round_abouttoend = false;
  roundend = false;
  printctmsg = false;

  SetupEntities();
  ResetTracking();

  for(new client = 1; client <= MaxClients; client++)
  if(IsClientInGame(client))
  {
    p_teamchooselock[client] = 0;

    // bugfix - the game does this only for alive players
    // so not for spectators that may have had ragdolls
    UnsetRagdollIndex(client);
  }

  if(roundreset)
  for(new client = 1; client <= MaxClients; client++)
  // reset all scores, no matter if clients are ingame
  {
    p_score[client] = 0;
    p_assist[client] = 0;

    p_owngoal[client] = 0;
  }

  roundreset = false;

  if(announcement_type == 0)
    PrintAnnouncementMsg(0);

  return;
}


public Event_RoundFreezeEnd(Handle:event,
                            const String:name[],
                            bool:dontBroadcast)
{
  round_freeze_end = GetTickedTime();
  return;
}


public Event_RoundEnd(Handle:event,
                      const String:name[],
                      bool:dontBroadcast)
{
  roundend = true;
  KillTriggers();

  for(new client = 1; client <= MaxClients; client++)
  // reset all spawned-states
    p_spawned_in_round[client] = false;

  if(GetEventInt(event, "reason") == 15)
  // game commencing
    roundreset = true;

  if(printctmsg)
    CenterMsg_NameBroadcast(centermsg_type, shooter_userid);

  if(!sv_nomvp
  && shooter_userid)
  // goal shooter to MVP
  {
    new Handle:round_mvp = CreateEvent("round_mvp", true);

    SetEventInt(round_mvp, "userid", shooter_userid);
    SetEventInt(round_mvp, "reason", 0);

    FireEvent(round_mvp, false);
  }

  return;
}


public Event_PlayerDeath(Handle:event,
                         const String:name[],
                         bool:dontBroadcast)
{
  new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
  new victim = GetClientOfUserId(GetEventInt(event, "userid"));

  // we have to do some modifications to the scores on death and suicide,
  // as this would otherwise pollute the scoretable

  if(attacker > 0
  && attacker != victim)
  // somehow someone killed somebody, maybe an admin turned off godmode?
    SetFrags(attacker, p_score[attacker]-1, false);
  else
  // someone died from world or suicide, different situation...
    SetFrags(victim, p_score[victim]+1, false);

  // in any case...
  SetDeaths(victim, p_assist[victim]-1);

  new shooter;

  if(p_died_from_goal[victim]
  && (shooter = GetClientOfUserId(shooter_userid))
  && IsClientInGame(shooter))
  // observertarget to goalshooter - also adds freezecam support
    SetEntPropEnt(victim, Prop_Send, "m_hObserverTarget", shooter);

  // respawn handling
  RespawnHandling(victim);
  return;
}
