// Forlix SoScore
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs

static Handle:p_rsp_blocktimer[MAXPLAYERS+1] = {INVALID_HANDLE, ...};


RespawnHandling(client)
{
  if(spawn_mode != 2
  || roundend
  || round_abouttoend)
    return;

  // initiate respawn blocktimer
  p_rsp_blocktimer[client] = CreateTimer(
  float(respawn_blocktime),
  ReleaseRespawnBlock,
  client);

  // respawn message
  CreateTimer(2.0, RespawnMsg, GetClientUserId(client));
  return;
}


public Action:ReleaseRespawnBlock(Handle:htimer,
                                  any:client)
{
  p_rsp_blocktimer[client] = INVALID_HANDLE;

  // remove the ragdoll
  RemoveRagdoll(client);

  if(!p_choosingclass[client])
  // player is not in the process of choosing a class
    RequestPlayerSpawn(client);

  return(Plugin_Stop);
}


AbortRespawnBlocktimer(client)
{
  if(spawn_mode)
  // remove the ragdoll
    RemoveRagdoll(client);

  if(p_rsp_blocktimer[client] == INVALID_HANDLE)
    return;

  KillTimer(p_rsp_blocktimer[client]);
  p_rsp_blocktimer[client] = INVALID_HANDLE;

  return;
}


RequestPlayerSpawn(client)
{
  if(!spawn_mode
  || roundend
  || round_abouttoend)
    return;

  if(spawn_mode == 1
  && p_spawned_in_round[client])
  // spawn mode = once only
  // and player has spawned once already
    return;

  CreateTimer(0.0, PlayerSpawn, GetClientUserId(client));
  return;
}


public Action:PlayerSpawn(Handle:htimer,
                          any:userid)
{
  new client = GetClientOfUserId(userid);

  if(!client
  || !IsClientInGame(client)
  || roundend)
    return(Plugin_Stop);

  if(p_rsp_blocktimer[client] != INVALID_HANDLE)
  // respawn block still active
  // just print respawn msg for now
  {
    CreateTimer(0.0, RespawnMsg, userid);
    return(Plugin_Stop);
  }

  if(!IsPlayerAlive(client)
  && GetClientTeam(client) > CS_TEAM_SPECTATOR)
    CS_RespawnPlayer(client);

  return(Plugin_Stop);
}


public Action:RespawnMsg(Handle:htimer,
                         any:userid)
{
  new client = GetClientOfUserId(userid);

  if(!client
  || !IsClientInGame(client)
  || IsPlayerAlive(client)
  || GetClientTeam(client) <= CS_TEAM_SPECTATOR
  || roundend
  || round_abouttoend)
    return(Plugin_Stop);

  PrintHintText(client, "%t", "RESPAWN_MSG");
  return(Plugin_Stop);
}


RemoveRagdoll(client)
{
  if(!IsClientInGame(client)
  || roundend)
    return;

  new ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");

  if(ragdoll > 0)
    RemoveEdict(ragdoll);

  UnsetRagdollIndex(client);
  return;
}


UnsetRagdollIndex(client)
{
  SetEntPropEnt(client, Prop_Send, "m_hRagdoll", -1);
  return;
}
